Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/console/console.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -833,94 +603,9 @@
 	}
 	
-	fb_get_resolution(fb_sess, &xres, &yres);
-	
-	/* Initialize the screen */
-	screen_vp = fb_vp_create(fb_sess, 0, 0, xres, yres);
-	
-	if ((xres >= 800) && (yres >= 600)) {
-		logo_vp = fb_vp_create(fb_sess, xres - 66, 2, 64, 60);
-		logo_img = imgmap_decode_tga((void *) helenos_tga,
-		    helenos_tga_size, IMGMAP_FLAG_SHARED);
-		logo_handle = fb_imagemap_create(fb_sess, logo_img);
-		
-		nameic_vp = fb_vp_create(fb_sess, 5, 17, 100, 26);
-		nameic_img = imgmap_decode_tga((void *) nameic_tga,
-		    nameic_tga_size, IMGMAP_FLAG_SHARED);
-		nameic_handle = fb_imagemap_create(fb_sess, nameic_img);
-		
-		cons_data_img = imgmap_decode_tga((void *) cons_data_tga,
-		    cons_data_tga_size, IMGMAP_FLAG_SHARED);
-		cons_dis_img = imgmap_decode_tga((void *) cons_dis_tga,
-		    cons_dis_tga_size, IMGMAP_FLAG_SHARED);
-		cons_dis_sel_img = imgmap_decode_tga((void *) cons_dis_sel_tga,
-		    cons_dis_sel_tga_size, IMGMAP_FLAG_SHARED);
-		cons_idle_img = imgmap_decode_tga((void *) cons_idle_tga,
-		    cons_idle_tga_size, IMGMAP_FLAG_SHARED);
-		cons_kernel_img = imgmap_decode_tga((void *) cons_kernel_tga,
-		    cons_kernel_tga_size, IMGMAP_FLAG_SHARED);
-		cons_sel_img = imgmap_decode_tga((void *) cons_sel_tga,
-		    cons_sel_tga_size, IMGMAP_FLAG_SHARED);
-		
-		state_icons[CONS_DISCONNECTED] =
-		    fb_imagemap_create(fb_sess, cons_dis_img);
-		state_icons[CONS_DISCONNECTED_SELECTED] =
-		    fb_imagemap_create(fb_sess, cons_dis_sel_img);
-		state_icons[CONS_SELECTED] =
-		    fb_imagemap_create(fb_sess, cons_sel_img);
-		state_icons[CONS_IDLE] =
-		    fb_imagemap_create(fb_sess, cons_idle_img);
-		state_icons[CONS_DATA] =
-		    fb_imagemap_create(fb_sess, cons_data_img);
-		state_icons[CONS_KERNEL] =
-		    fb_imagemap_create(fb_sess, cons_kernel_img);
-		
-		anim_1_img = imgmap_decode_tga((void *) anim_1_tga,
-		    anim_1_tga_size, IMGMAP_FLAG_SHARED);
-		anim_2_img = imgmap_decode_tga((void *) anim_2_tga,
-		    anim_2_tga_size, IMGMAP_FLAG_SHARED);
-		anim_3_img = imgmap_decode_tga((void *) anim_3_tga,
-		    anim_3_tga_size, IMGMAP_FLAG_SHARED);
-		anim_4_img = imgmap_decode_tga((void *) anim_4_tga,
-		    anim_4_tga_size, IMGMAP_FLAG_SHARED);
-		
-		anim_1 = fb_imagemap_create(fb_sess, anim_1_img);
-		anim_2 = fb_imagemap_create(fb_sess, anim_2_img);
-		anim_3 = fb_imagemap_create(fb_sess, anim_3_img);
-		anim_4 = fb_imagemap_create(fb_sess, anim_4_img);
-		
-		anim_seq = fb_sequence_create(fb_sess);
-		fb_sequence_add_imagemap(fb_sess, anim_seq, anim_1);
-		fb_sequence_add_imagemap(fb_sess, anim_seq, anim_2);
-		fb_sequence_add_imagemap(fb_sess, anim_seq, anim_3);
-		fb_sequence_add_imagemap(fb_sess, anim_seq, anim_4);
-		
-		console_vp = fb_vp_create(fb_sess, CONSOLE_MARGIN, CONSOLE_TOP,
-		    xres - 2 * CONSOLE_MARGIN, yres - (CONSOLE_TOP + CONSOLE_MARGIN));
-		
-		fb_vp_clear(fb_sess, screen_vp);
-		fb_vp_imagemap_damage(fb_sess, logo_vp, logo_handle,
-		    0, 0, 64, 60);
-		fb_vp_imagemap_damage(fb_sess, nameic_vp, nameic_handle,
-		    0, 0, 100, 26);
-		
-		graphics_state = GRAPHICS_FULL;
-	} else {
-		console_vp = screen_vp;
-		graphics_state = GRAPHICS_BASIC;
-	}
-	
-	fb_vp_set_style(fb_sess, console_vp, STYLE_NORMAL);
-	fb_vp_clear(fb_sess, console_vp);
-	
-	sysarg_t cols;
-	sysarg_t rows;
-	fb_vp_get_dimensions(fb_sess, console_vp, &cols, &rows);
+	output_get_dimensions(output_sess, &cols, &rows);
+	output_set_style(output_sess, STYLE_NORMAL);
 	
 	console_caps_t ccaps;
-	fb_vp_get_caps(fb_sess, console_vp, &ccaps);
-	
-	mouse.x = xres / 2;
-	mouse.y = yres / 2;
-	mouse.pressed = false;
+	output_get_caps(output_sess, &ccaps);
 	
 	/* Inititalize consoles */
@@ -930,24 +615,8 @@
 		fibril_mutex_initialize(&consoles[i].mtx);
 		prodcons_initialize(&consoles[i].input_pc);
-		
-		if (graphics_state == GRAPHICS_FULL) {
-			/* Create state buttons */
-			consoles[i].state_vp =
-			    fb_vp_create(fb_sess, STATE_START + (xres - 800) / 2 +
-			    CONSOLE_MARGIN + i * (STATE_WIDTH + STATE_SPACE),
-			    STATE_TOP, STATE_WIDTH, STATE_HEIGHT);
-		}
-		
-		if (i == KERNEL_CONSOLE) {
-			consoles[i].state = CONS_KERNEL;
-			cons_redraw_state(&consoles[i]);
-			cons_kernel_sequence_start(&consoles[i]);
+		consoles[i].char_remains_len = 0;
+		
+		if (i == KERNEL_CONSOLE)
 			continue;
-		}
-		
-		if (i == 0)
-			consoles[i].state = CONS_DISCONNECTED_SELECTED;
-		else
-			consoles[i].state = CONS_DISCONNECTED;
 		
 		consoles[i].cols = cols;
@@ -955,5 +624,5 @@
 		consoles[i].ccaps = ccaps;
 		consoles[i].frontbuf =
-		    screenbuffer_create(cols, rows, SCREENBUFFER_FLAG_SHARED);
+		    chargrid_create(cols, rows, CHARGRID_FLAG_SHARED);
 		
 		if (consoles[i].frontbuf == NULL) {
@@ -962,5 +631,6 @@
 		}
 		
-		consoles[i].fbid = fb_frontbuf_create(fb_sess, consoles[i].frontbuf);
+		consoles[i].fbid = output_frontbuf_create(output_sess,
+		    consoles[i].frontbuf);
 		if (consoles[i].fbid == 0) {
 			printf("%s: Unable to create frontbuffer %zu\n", NAME, i);
@@ -968,5 +638,7 @@
 		}
 		
-		cons_redraw_state(&consoles[i]);
+		con_srvs_init(&consoles[i].srvs);
+		consoles[i].srvs.ops = &con_ops;
+		consoles[i].srvs.sarg = &consoles[i];
 		
 		char vc[LOC_NAME_MAXLEN + 1];
@@ -978,4 +650,6 @@
 		}
 	}
+	
+	cons_damage(active_console);
 	
 	/* Receive kernel notifications */
@@ -989,7 +663,7 @@
 }
 
-static void usage(void)
-{
-	printf("Usage: console <input_dev> <framebuffer_dev>\n");
+static void usage(char *name)
+{
+	printf("Usage: %s <input_dev> <output_dev>\n", name);
 }
 
@@ -997,5 +671,5 @@
 {
 	if (argc < 3) {
-		usage();
+		usage(argv[0]);
 		return -1;
 	}
@@ -1010,4 +684,5 @@
 	async_manager();
 	
+	/* Never reached */
 	return 0;
 }
Index: uspace/srv/hid/input/Makefile
===================================================================
--- uspace/srv/hid/input/Makefile	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/Makefile	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -29,12 +29,7 @@
 
 USPACE_PREFIX = ../../..
-EXTRA_CFLAGS = -Iinclude
 BINARY = input
 
 SOURCES = \
-	generic/gsp.c \
-	generic/input.c \
-	generic/layout.c \
-	generic/stroke.c \
 	layout/cz.c \
 	layout/us_qwerty.c \
@@ -56,5 +51,9 @@
 	ctl/pc.c \
 	ctl/stty.c \
-	ctl/sun.c
+	ctl/sun.c \
+	gsp.c \
+	input.c \
+	layout.c \
+	stroke.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/srv/hid/input/ctl/apple.c
===================================================================
--- uspace/srv/hid/input/ctl/apple.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/ctl/apple.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -36,9 +36,9 @@
  */
 
-#include <kbd.h>
 #include <io/console.h>
 #include <io/keycode.h>
-#include <kbd_ctl.h>
-#include <kbd_port.h>
+#include "../kbd.h"
+#include "../kbd_ctl.h"
+#include "../kbd_port.h"
 
 static void apple_ctl_parse(sysarg_t);
Index: uspace/srv/hid/input/ctl/gxe_fb.c
===================================================================
--- uspace/srv/hid/input/ctl/gxe_fb.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/ctl/gxe_fb.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -33,14 +33,14 @@
 /**
  * @file
- * @brief	GXEmul framebuffer-mode keyboard controller driver.
+ * @brief GXEmul framebuffer-mode keyboard controller driver.
  */
 
-#include <kbd.h>
 #include <io/console.h>
 #include <io/keycode.h>
-#include <kbd_ctl.h>
-#include <kbd_port.h>
-#include <gsp.h>
-#include <stroke.h>
+#include "../stroke.h"
+#include "../gsp.h"
+#include "../kbd.h"
+#include "../kbd_port.h"
+#include "../kbd_ctl.h"
 
 static void gxe_fb_ctl_parse(sysarg_t);
Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -40,16 +40,16 @@
 #include <errno.h>
 #include <fcntl.h>
-#include <gsp.h>
 #include <io/console.h>
 #include <io/keycode.h>
 #include <ipc/kbdev.h>
-#include <input.h>
-#include <kbd.h>
-#include <kbd_ctl.h>
-#include <kbd_port.h>
 #include <loc.h>
 #include <stdlib.h>
 #include <vfs/vfs_sess.h>
 #include <sys/typefmt.h>
+#include "../gsp.h"
+#include "../input.h"
+#include "../kbd.h"
+#include "../kbd_ctl.h"
+#include "../kbd_port.h"
 
 static int kbdev_ctl_init(kbd_dev_t *);
Index: uspace/srv/hid/input/ctl/pc.c
===================================================================
--- uspace/srv/hid/input/ctl/pc.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/ctl/pc.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -36,10 +36,10 @@
  */
 
-#include <kbd.h>
 #include <io/console.h>
 #include <io/keycode.h>
-#include <kbd_ctl.h>
-#include <kbd_port.h>
-#include <gsp.h>
+#include "../gsp.h"
+#include "../kbd.h"
+#include "../kbd_port.h"
+#include "../kbd_ctl.h"
 
 static void pc_ctl_parse(sysarg_t);
Index: uspace/srv/hid/input/ctl/stty.c
===================================================================
--- uspace/srv/hid/input/ctl/stty.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/ctl/stty.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -38,10 +38,10 @@
  */
 
-#include <kbd.h>
 #include <io/keycode.h>
-#include <kbd_ctl.h>
-#include <kbd_port.h>
-#include <gsp.h>
-#include <stroke.h>
+#include "../stroke.h"
+#include "../gsp.h"
+#include "../kbd.h"
+#include "../kbd_port.h"
+#include "../kbd_ctl.h"
 
 static void stty_ctl_parse(sysarg_t);
Index: uspace/srv/hid/input/ctl/sun.c
===================================================================
--- uspace/srv/hid/input/ctl/sun.c	(revision 141a20dc6c36e09dab74a968f1a80bf74ddeacc6)
+++ uspace/srv/hid/input/ctl/sun.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -37,9 +37,9 @@
  */
 
-#include <kbd.h>
 #include <io/console.h>
 #include <io/keycode.h>
-#include <kbd_ctl.h>
-#include <kbd_port.h>
+#include "../kbd.h"
+#include "../kbd_port.h"
+#include "../kbd_ctl.h"
 
 static void sun_ctl_parse(sysarg_t);
Index: uspace/srv/hid/input/gsp.c
===================================================================
--- uspace/srv/hid/input/gsp.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/srv/hid/input/gsp.c	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,286 @@
+/*
+ * Copyright (c) 2009 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/**
+ * @addtogroup kbdgen generic
+ * @ingroup  input
+ * @{
+ */
+/** @file
+ * @brief Generic scancode parser.
+ *
+ * The scancode parser is a simple finite state machine. It is described
+ * using sequences of input symbols (scancodes) and the corresponding output
+ * value (mods, key pair). When the parser recognizes a sequence,
+ * it outputs the value and restarts. If a transition is undefined,
+ * the parser restarts, too.
+ *
+ * Apart from precise values, GSP_DEFAULT allows to catch general cases.
+ * I.e. if we knew that after 0x1b 0x4f there always follow two more
+ * scancodes, we can define (0x1b, 0x4f, GSP_DEFAULT, GSP_DEFAULT, GSP_END)
+ * with null output. This will force the parser to read the entire sequence,
+ * not leaving garbage on the input if it does not recognize the specific
+ * sequence.
+ */
+
+#include <adt/hash_table.h>
+#include <adt/hash.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include "gsp.h"
+
+/*
+ * Transition function hash table operations.
+ */
+typedef struct {
+	int old_state;
+	int input;
+} trans_key_t;
+
+static size_t trans_key_hash(void *key)
+{
+	trans_key_t *trans_key = (trans_key_t *)key;
+	return hash_combine(trans_key->input, trans_key->old_state);
+}
+
+static size_t trans_hash(const ht_link_t *item)
+{
+	gsp_trans_t *t = hash_table_get_inst(item, gsp_trans_t, link);
+	return hash_combine(t->input, t->old_state);
+}
+
+static bool trans_key_equal(void *key, const ht_link_t *item)
+{
+	trans_key_t *trans_key = (trans_key_t *)key;
+	gsp_trans_t *t = hash_table_get_inst(item, gsp_trans_t, link);
+	
+	return trans_key->input == t->input && trans_key->old_state == t->old_state;
+}
+
+static hash_table_ops_t trans_ops = {
+	.hash = trans_hash,
+	.key_hash = trans_key_hash,
+	.key_equal = trans_key_equal,
+	.equal = NULL,
+	.remove_callback = NULL
+};
+
+
+static gsp_trans_t *trans_lookup(gsp_t *p, int state, int input);
+static void trans_insert(gsp_t *p, gsp_trans_t *t);
+static gsp_trans_t *trans_new(void);
+
+/** Initialize scancode parser. */
+void gsp_init(gsp_t *p)
+{
+	p->states = 1;
+	hash_table_create(&p->trans, 0, 0, &trans_ops);
+}
+
+/** Insert a series of definitions into the parser.
+ *
+ * @param p	The parser.
+ * @param defs	Definition list. Each definition starts with two output values
+ *		(mods, key) and continues with a sequence of input values
+ *		terminated with GSP_END. The definition list is terminated
+ *		with two zeroes (0, 0) for output values.
+ */
+int gsp_insert_defs(gsp_t *p, const int *defs)
+{
+	unsigned mods, key;
+	const int *dp;
+	int rc;
+
+	dp = defs;
+
+	while (1) {
+		/* Read the output values. */
+		mods = *dp++;
+		key = *dp++;
+		if (key == 0) break;
+
+		/* Insert one sequence. */
+		rc = gsp_insert_seq(p, dp, mods, key);
+		if (rc != 0)
+			return rc;
+
+		/* Skip to the next definition. */
+		while (*dp != GSP_END)
+			++dp;
+		++dp;
+	}
+
+	return 0;
+}
+
+/** Insert one sequence into the parser.
+ *
+ * @param p	The parser.
+ * @param seq	Sequence of input values terminated with GSP_END.
+ * @param mods	Corresponsing output value.
+ * @param key	Corresponsing output value.
+ */
+int gsp_insert_seq(gsp_t *p, const int *seq, unsigned mods, unsigned key)
+{
+	int state;
+	gsp_trans_t *t;
+
+	state = 0;
+	t = NULL;
+
+	/* Input sequence must be non-empty. */
+	if (*seq == GSP_END)
+		return -1;
+
+	while (*(seq + 1) != GSP_END) {
+		t = trans_lookup(p, state, *seq);
+		if (t == NULL) {
+			/* Create new state. */
+			t = trans_new();
+			t->old_state = state;
+			t->input = *seq;
+			t->new_state = p->states++;
+
+			t->out_mods = 0;
+			t->out_key = 0;
+
+			trans_insert(p, t);
+		}
+		state = t->new_state;
+		++seq;
+	}
+
+	/* Process the last transition. */
+	t = trans_lookup(p, state, *seq);
+	if (t != NULL) {
+		exit(1);
+		return -1;	/* Conflicting definition. */
+	}
+
+	t = trans_new();
+	t->old_state = state;
+	t->input = *seq;
+	t->new_state = 0;
+
+	t->out_mods = mods;
+	t->out_key = key;
+
+	trans_insert(p, t);
+
+	return 0;
+}
+
+/** Compute one parser step.
+ *
+ * Computes the next state and output values for a given state and input.
+ * This handles everything including restarts and default branches.
+ *
+ * @param p		The parser.
+ * @param state		Old state.
+ * @param input		Input symbol (scancode).
+ * @param mods		Output value (modifier).
+ * @param key		Output value (key).
+ * @return		New state.
+ */
+int gsp_step(gsp_t *p, int state, int input, unsigned *mods, unsigned *key)
+{
+	gsp_trans_t *t;
+
+	t = trans_lookup(p, state, input);
+	if (t == NULL) {
+		t = trans_lookup(p, state, GSP_DEFAULT);
+	}
+
+	if (t == NULL) {
+		printf("gsp_step: not found, state=%d, input=0x%x\n",
+		    state, input);
+		*mods = 0;
+		*key = 0;
+		return 0;
+	}
+
+	*mods = t->out_mods;
+	*key = t->out_key;
+
+	return t->new_state;
+}
+
+/** Transition function lookup.
+ *
+ * Returns the value of the transition function for the given state
+ * and input. Note that the transition must be specified precisely,
+ * to obtain the default branch use input = GSP_DEFAULT.
+ *
+ * @param p		Parser.
+ * @param state		Current state.
+ * @param input		Input value.
+ * @return		The transition or @c NULL if not defined.
+ */
+static gsp_trans_t *trans_lookup(gsp_t *p, int state, int input)
+{
+	ht_link_t *item;
+	
+	trans_key_t key = {
+		.input = input,
+		.old_state = state
+	};
+
+	item = hash_table_find(&p->trans, &key);
+	if (item == NULL) return NULL;
+
+	return hash_table_get_inst(item, gsp_trans_t, link);
+}
+
+/** Define a new transition.
+ *
+ * @param p	The parser.
+ * @param t	Transition with all fields defined.
+ */
+static void trans_insert(gsp_t *p, gsp_trans_t *t)
+{
+	hash_table_insert(&p->trans, &t->link);
+}
+
+/** Allocate transition structure. */
+static gsp_trans_t *trans_new(void)
+{
+	gsp_trans_t *t;
+
+	t = malloc(sizeof(gsp_trans_t));
+	if (t == NULL) {
+		printf("Memory allocation failed.\n");
+		exit(1);
+	}
+
+	return t;
+}
+
+
+/**
+ * @}
+ */ 
Index: uspace/srv/hid/input/gsp.h
===================================================================
--- uspace/srv/hid/input/gsp.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
+++ uspace/srv/hid/input/gsp.h	(revision a1e2df13d3b8476ed4b89d3959aef8eeed6ac73f)
@@ -0,0 +1,84 @@
+/*
+ * Copyright (c) 2009 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup inputgen generic
+ * @brief	Generic scancode parser.
+ * @ingroup  input
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KBD_GSP_H_
+#define KBD_GSP_H_
+
+#include <adt/hash_table.h>
+
+enum {
+	GSP_END		= -1,	/**< Terminates a sequence. */
+	GSP_DEFAULT	= -2	/**< Wildcard, catches unhandled cases. */
+};
+
+/** Scancode parser description */
+typedef struct {
+	/** Transition table, (state, input) -> (state, output) */
+	hash_table_t trans;
+
+	/** Number of states */
+	int states;
+} gsp_t;
+
+/** Scancode parser transition. */
+typedef struct {
+	ht_link_t link;		/**< Link to hash table in @c gsp_t */ 
+
+	/* Preconditions */
+
+	int old_state;		/**< State before transition */
+	int input;		/**< Input symbol (scancode) */
+
+	/* Effects */
+
+	int new_state;		/**< State after transition */
+
+	/* Output emitted during transition */
+
+	unsigned out_mods;	/**< Modifier to emit */
+	unsigned out_key;	/**< Keycode to emit */
+} gsp_trans_t;
+
+extern void gsp_init(gsp_t *);
+extern int gsp_insert_defs(gsp_t *, const int *);
+extern int gsp_insert_seq(gsp_t *, const int *, unsigned, unsigned);
+extern int gsp_step(gsp_t *, int, int, unsigned *, unsigned *);
+
+#endif
+
+/**
+ * @}
+ */ 
